﻿------------------------------------------------------------------------------------------
--Monk Chi--------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local BORDER = 2
local unpack = unpack
local collectgarbage = collectgarbage
local SPELL_POWER_CHI = SPELL_POWER_CHI
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax

function SN:Chi(frame)
	local CLASSBAR_WIDTH = SN.data.profile.classResources.width - (BORDER*2)
	local color = M.classResources.MONK
	local maxChi = SN['classMaxResourceBar']["MONK"]

	local chi = CreateFrame("Frame", nil, frame)
	chi:SetSize(CLASSBAR_WIDTH, SN.data.profile.classResources.height)
	chi:SetPoint("CENTER", frame, "CENTER", 0, 0)
	chi.maxChi = maxChi

	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(chi, "Frame")
	else
		chi:SetBackdrop({
			bgFile = M.media.blankTex, 
			edgeFile = M.media.blankTex, 
			tile = false, tileSize = 0, edgeSize = 2, 
			insets = { left = 2, right = 2, top = 2, bottom = 2 }
			})
		chi:SetBackdropColor(0.1, 0.1, 0.1, 1)
		chi:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end

	for i = 1, maxChi do
		chi[i] = CreateFrame("StatusBar", nil, chi)
		chi[i]:SetSize((SN.data.profile.classResources.width - 22) / maxChi, SN.data.profile.classResources.height - 6)
		if i == 1 then
			chi[i]:SetPoint("LEFT", chi, 3, 0)
		else
			chi[i]:SetPoint("LEFT", chi[(i - 1)], "RIGHT", 3, 0)
		end
		
		chi[i]:SetStatusBarTexture(LSM:Fetch("statusbar", SN.data.profile.classResources.texture))
		chi[i]:GetStatusBarTexture():SetHorizTile(false)
		chi[i]:SetMinMaxValues(0, 1)
		chi[i]:SetValue(1)
		chi[i]:SetStatusBarColor(unpack(color[i]))
		chi[i]:Hide()
	end
	
	return chi
end

function SN:SetupChi()
	if SN.playerClass ~= "MONK" then return end
	local frame = F.classpower

	frame.chi = SN:Chi(frame)
	frame.chi:RegisterEvent("PLAYER_ENTERING_WORLD")
	frame.chi:RegisterEvent("UNIT_POWER")
	frame.chi:RegisterEvent("UNIT_DISPLAYPOWER")
	frame.chi:RegisterEvent("PLAYER_LEVEL_UP")

	frame.chi:SetScript("OnEvent", function(self, event, ...)

		if event == "UNIT_POWER" or event == "UNIT_DISPLAYPOWER" then
			local light = UnitPower("player", SPELL_POWER_CHI)
			local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

			for i = 1, numPoints do
				if i <= light then
					self[i]:SetAlpha(1)
				else
					self[i]:SetAlpha(0.1)
				end
				self[i]:SetSize((SN.data.profile.classResources.width - 16) / numPoints, SN.data.profile.classResources.height - 6)
				self[i]:Show()
				if numPoints < self.maxChi then
					self[self.maxChi]:Hide()
				end
			end
		end
		if event == "PLAYER_ENTERING_WORLD" then
			local light = UnitPower("player", SPELL_POWER_CHI)
			local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

			for i = 1, numPoints do
				if i <= light then
					self[i]:SetAlpha(1)
				else
					self[i]:SetAlpha(0.1)
				end
				self[i]:SetSize((SN.data.profile.classResources.width - 16) / numPoints, SN.data.profile.classResources.height - 6)
				self[i]:Show()
			end
		end
	end)

	local light = UnitPower("player", SPELL_POWER_CHI)
	local numPoints = UnitPowerMax("player", SPELL_POWER_CHI)

	for i = 1, numPoints do
		if i <= light then
			frame.chi[i]:SetAlpha(1)
		else
			frame.chi[i]:SetAlpha(0.1)
		end
		frame.chi[i]:SetSize((SN.data.profile.classResources.width - 16) / numPoints, SN.data.profile.classResources.height - 6)
		frame.chi[i]:Show()
		if numPoints < frame.chi.maxChi then
			frame.chi[frame.chi.maxChi]:Hide()
		end
	end
end

local function Update(self, event, unit)
	--if unit == "player" then
		
	--end
end

function SN:ChiEnable()
	local frame = F.classpower
	frame.chi:Show()
end

function SN:ChiDisable()
	local frame = F.classpower
	frame.chi:Hide()
	collectgarbage("collect")
end