﻿------------------------------------------------------------------------------------------
--Holy Power------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local BORDER = 2
local SPELL_POWER_HOLY_POWER = SPELL_POWER_HOLY_POWER
local MAX_HOLY_POWER = 5
local UnitPower = UnitPower
local IsAddOnLoaded = IsAddOnLoaded
local collectgarbage = collectgarbage
local unpack = unpack

function SN:HPower(frame)
	local CLASSBAR_WIDTH = F.classpower:GetWidth() - (BORDER*2)
	local color = M.classResources.PALADIN

	local holypower = CreateFrame("Frame", nil, frame)
	holypower:SetSize(CLASSBAR_WIDTH, SN.data.profile.classResources.height)
	holypower:SetPoint("CENTER", frame, "CENTER", 0, 0)

	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(holypower, "Frame")
	else
		holypower:SetBackdrop({
			bgFile = M.media.blankTex, 
			edgeFile = M.media.blankTex, 
			tile = false, tileSize = 0, edgeSize = 2, 
			insets = { left = 2, right = 2, top = 2, bottom = 2 }
			})
		holypower:SetBackdropColor(0.1, 0.1, 0.1, 1)
		holypower:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end

	for i = 1, MAX_HOLY_POWER do
		holypower[i] = CreateFrame("StatusBar", nil, holypower)
		holypower[i]:SetSize((SN.data.profile.classResources.width - 22) / MAX_HOLY_POWER, SN.data.profile.classResources.height - 6)
		if i == 1 then
			holypower[i]:SetPoint("LEFT", holypower, 3, 0)
		else
			holypower[i]:SetPoint("LEFT", holypower[(i - 1)], "RIGHT", 3, 0)
		end
		holypower[i]:SetStatusBarTexture(LSM:Fetch("statusbar", SN.data.profile.classResources.texture))
		holypower[i]:GetStatusBarTexture():SetHorizTile(false)
		holypower[i]:SetMinMaxValues(0, 1)
		holypower[i]:SetValue(1)
		holypower[i]:SetStatusBarColor(unpack(color))
	end
	
	return holypower
end

function SN:SetupHoly()
	if SN.playerClass ~= "PALADIN" then return end
	local frame = F.classpower

	frame.holypower = SN:HPower(frame)
	frame.holypower:RegisterEvent("UNIT_POWER")
	frame.holypower:SetScript("OnEvent", function(self, event, ...)

		if event == "UNIT_POWER" then
			local unitID, type = ...
			if unitID == "player" and type == "HOLY_POWER" then
				local hpower = UnitPower("player", SPELL_POWER_HOLY_POWER)
				if hpower > 0 then
					for i = 1, MAX_HOLY_POWER do
						self[i]:SetAlpha(0.1)
					end
					for i = 1, hpower do
						self[i]:SetAlpha(1)
					end
				else
					for i = 1, MAX_HOLY_POWER do
						self[i]:SetAlpha(0.1)
					end
				end
			end
		end
	end)
	local hpower = UnitPower("player", SPELL_POWER_HOLY_POWER)
	if hpower > 0 then
		for i = 1, hpower do
			frame.holypower[i]:SetAlpha(1)
		end
	else
		for i = 1, MAX_HOLY_POWER do
			frame.holypower[i]:SetAlpha(0.1)
		end
	end
end

function SN:HolyEnable()
	local frame = F.classpower
	frame.holypower:Show()
	frame.holypower:RegisterEvent("UNIT_POWER")
end

function SN:HolyDisable()
	local frame = F.classpower
	frame.holypower:UnregisterEvent("UNIT_POWER")
	frame.holypower:Hide()
	collectgarbage("collect")
end